--[[
	##AddOn	: ShortenGold
	##Subfile 	: main.lua
	##Author 	: Hati ( xhatix on wowace.com )
--]]
local SG = CreateFrame("Frame",nil)
SG:RegisterEvent("PLAYER_LOGOUT")
local tinsert,gsub,strlower = tinsert,gsub,strlower
local replaceBy = {
    "|TInterface\\MoneyFrame\\UI-GoldIcon:14:14:2:0|t",
    "|TInterface\\MoneyFrame\\UI-SilverIcon:14:14:2:0|t",
    "|TInterface\\MoneyFrame\\UI-CopperIcon:14:14:2:0|t",
}
SG:SetScript('OnEvent',function(self,event,...)
    if SG.db then 
        _G.ShortenGoldLoot_DB = SG.db
    end
end)

SG.ReplaceMsg = function(self,text)
    for index,type in ipairs(SG.locale) do
        --print(text,type,replaceTextures[index])
        text=string.gsub(text,type.."%,?",replaceBy[index] or "")
    end
    return text
end

SG.InitLocale = function()
    SG.locale = {}
    if not SG.db then SG:InitDB() end
    tinsert(SG.locale,strsub(GOLD_AMOUNT,3))
    tinsert(SG.locale,strsub(SILVER_AMOUNT,3))
    tinsert(SG.locale,strsub(COPPER_AMOUNT,3))
    if SG.db.cashflow then
        tinsert(SG.locale,"%s%b()")
    end
end

SG.GoldReplace = function(self,event,msg,author,...)
    if not SG.locale then SG:InitLocale() end
    return false, SG:ReplaceMsg(msg),author,...
end
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONEY",SG.GoldReplace)
--/MainCode

--\OptionCode
SG.InitDB = function(self)
    SG.db = _G.ShortenGoldLoot_DB
    if type(SG.db)=='table' then return 
    else
        SG.db = { }
        SG.db.cashflow = false
   end
end

local function ToggleCashFlow()
    if SG.db.cashflow then
        print('ShortenGoldLoot: Cashflow addition is now hidden.')
        tDeleteItem(SG.locale,"%s%b()")
        SG.db.cashflow=false
    else
        print('ShortenGoldLoot: Cashflow is now shown again.')
        tinsert(SG.locale,"%s%b()")
        SG.db.cashflow=true
    end
end

local optionText = {
    --cmd -> function
    ["cashflow"] = ToggleCashFlow
}

local function validFunc(name)
    for opt,_ in pairs(optionText) do
        if opt==name then return true end
    end
end

SLASH_ShortenGoldLoot1 = '/sgl'
SLASH_ShortenGoldLoot2 = '/shortengoldloot'
function SlashCmdList.ShortenGoldLoot(msg,editbox)
    if not SG.locale then SG:InitLocale() end
	msg = strlower(msg)
    if validFunc(msg) then
        optionText[msg]()
    else
        print("ShortenGoldLoot: valid slash commands")
        print("/sgl")
        print("* cashflow")
    end
end
--/OptionCode